`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2020/05/08 18:12:55
// Design Name: 
// Module Name: freq_div
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module freq_div(
    input clk,
    input rst_n,
    output reg [1:0]clk_ctl,
    output reg clk_1Hz,
    output reg clk_100Hz
    );
    reg [25:0]cnt_tmp1, cnt_tmp2;
    reg [8:0]cnt_h;
    reg [14:0]cnt_l;
    reg clk_tmp1, clk_tmp2;
    reg [25:0]cnt;
    
// for generating 1Hz frequency
always@*
    if({cnt_h,clk_ctl,cnt_l} == 26'd50000000)
        begin
            cnt_tmp1 = 26'b0;
            clk_tmp1 = ~clk_1Hz;
        end
    else
        begin
            cnt_tmp1 = {cnt_h,clk_ctl,cnt_l} + 1;
            clk_tmp1 = clk_1Hz;
        end

// for generating 100Hz frequency
always@*
    if(cnt == 26'd500000)
        begin
            cnt_tmp2 = 26'b0;
            clk_tmp2 = ~clk_100Hz;
        end
    else
        begin
            cnt_tmp2 = cnt + 1;
            clk_tmp2 = clk_100Hz;
        end
     
always@(posedge clk or negedge rst_n)
    if(~rst_n)
        begin
            {cnt_h,clk_ctl,cnt_l} <= 26'b0;
            cnt <= 26'b0;
            clk_1Hz <= 1'b0;
            clk_100Hz <= 1'b0;
        end
    else
        begin
            {cnt_h,clk_ctl,cnt_l} <= cnt_tmp1;
            cnt <= cnt_tmp2;
            clk_1Hz <= clk_tmp1;
            clk_100Hz <= clk_tmp2;
        end

endmodule
